/*
 * [The "BSD license"]
 *  Copyright (c) 2012 Terence Parr
 *  Copyright (c) 2012 Sam Harwell
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. The name of the author may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.antlr.v4.runtime.tree.gui;

public class ArialBlack extends BasicFontMetrics {
    {
		maxCharHeight = 905;
        widths[32] = 333; // space
        widths[33] = 333; // exclam
        widths[34] = 500; // quotedbl
        widths[35] = 660; // numbersign
        widths[36] = 666; // dollar
        widths[37] = 1000; // percent
        widths[38] = 889; // ampersand
        widths[39] = 277; // quotesingle
        widths[40] = 389; // parenleft
        widths[41] = 389; // parenright
        widths[42] = 556; // asterisk
        widths[43] = 660; // plus
        widths[44] = 333; // comma
        widths[45] = 333; // hyphen
        widths[46] = 333; // period
        widths[47] = 277; // slash
        widths[48] = 666; // zero
        widths[49] = 666; // one
        widths[50] = 666; // two
        widths[51] = 666; // three
        widths[52] = 666; // four
        widths[53] = 666; // five
        widths[54] = 666; // six
        widths[55] = 666; // seven
        widths[56] = 666; // eight
        widths[57] = 666; // nine
        widths[58] = 333; // colon
        widths[59] = 333; // semicolon
        widths[60] = 660; // less
        widths[61] = 660; // equal
        widths[62] = 660; // greater
        widths[63] = 610; // question
        widths[64] = 740; // at
        widths[65] = 777; // A
        widths[66] = 777; // B
        widths[67] = 777; // C
        widths[68] = 777; // D
        widths[69] = 722; // E
        widths[70] = 666; // F
        widths[71] = 833; // G
        widths[72] = 833; // H
        widths[73] = 389; // I
        widths[74] = 666; // J
        widths[75] = 833; // K
        widths[76] = 666; // L
        widths[77] = 943; // M
        widths[78] = 833; // N
        widths[79] = 833; // O
        widths[80] = 722; // P
        widths[81] = 833; // Q
        widths[82] = 777; // R
        widths[83] = 722; // S
        widths[84] = 722; // T
        widths[85] = 833; // U
        widths[86] = 777; // V
        widths[87] = 1000; // W
        widths[88] = 777; // X
        widths[89] = 777; // Y
        widths[90] = 722; // Z
        widths[91] = 389; // bracketleft
        widths[92] = 277; // backslash
        widths[93] = 389; // bracketright
        widths[94] = 660; // asciicircum
        widths[95] = 500; // underscore
        widths[96] = 333; // grave
        widths[97] = 666; // a
        widths[98] = 666; // b
        widths[99] = 666; // c
        widths[100] = 666; // d
        widths[101] = 666; // e
        widths[102] = 389; // f
        widths[103] = 666; // g
        widths[104] = 666; // h
        widths[105] = 333; // i
        widths[106] = 333; // j
        widths[107] = 666; // k
        widths[108] = 333; // l
        widths[109] = 1000; // m
        widths[110] = 666; // n
        widths[111] = 666; // o
        widths[112] = 666; // p
        widths[113] = 666; // q
        widths[114] = 443; // r
        widths[115] = 610; // s
        widths[116] = 443; // t
        widths[117] = 666; // u
        widths[118] = 610; // v
        widths[119] = 943; // w
        widths[120] = 666; // x
        widths[121] = 610; // y
        widths[122] = 556; // z
        widths[123] = 389; // braceleft
        widths[124] = 277; // bar
        widths[125] = 389; // braceright
        widths[126] = 660; // asciitilde
		widths[160] = 333; // nbspace
		widths[161] = 333; // exclamdown
		widths[162] = 666; // cent
		widths[163] = 666; // sterling
		widths[164] = 660; // currency
		widths[165] = 666; // yen
		widths[166] = 277; // brokenbar
		widths[167] = 666; // section
		widths[168] = 333; // dieresis
		widths[169] = 799; // copyright
		widths[170] = 399; // ordfeminine
		widths[171] = 666; // guillemotleft
		widths[172] = 660; // logicalnot
		widths[173] = 333; // sfthyphen
		widths[174] = 799; // registered
		widths[175] = 500; // overscore
		widths[176] = 399; // degree
		widths[177] = 660; // plusminus
		widths[178] = 399; // twosuperior
		widths[179] = 399; // threesuperior
		widths[180] = 333; // acute
		widths[181] = 666; // mu1
		widths[182] = 850; // paragraph
		widths[183] = 333; // middot
		widths[184] = 333; // cedilla
		widths[185] = 399; // onesuperior
		widths[186] = 399; // ordmasculine
		widths[187] = 666; // guillemotright
		widths[188] = 1000; // onequarter
		widths[189] = 1000; // onehalf
		widths[190] = 1000; // threequarters
		widths[191] = 610; // questiondown
		widths[192] = 777; // Agrave
		widths[193] = 777; // Aacute
		widths[194] = 777; // Acircumflex
		widths[195] = 777; // Atilde
		widths[196] = 777; // Adieresis
		widths[197] = 777; // Aring
		widths[198] = 1000; // AE
		widths[199] = 777; // Ccedilla
		widths[200] = 722; // Egrave
		widths[201] = 722; // Eacute
		widths[202] = 722; // Ecircumflex
		widths[203] = 722; // Edieresis
		widths[204] = 389; // Igrave
		widths[205] = 389; // Iacute
		widths[206] = 389; // Icircumflex
		widths[207] = 389; // Idieresis
		widths[208] = 777; // Eth
		widths[209] = 833; // Ntilde
		widths[210] = 833; // Ograve
		widths[211] = 833; // Oacute
		widths[212] = 833; // Ocircumflex
		widths[213] = 833; // Otilde
		widths[214] = 833; // Odieresis
		widths[215] = 660; // multiply
		widths[216] = 833; // Oslash
		widths[217] = 833; // Ugrave
		widths[218] = 833; // Uacute
		widths[219] = 833; // Ucircumflex
		widths[220] = 833; // Udieresis
		widths[221] = 777; // Yacute
		widths[222] = 722; // Thorn
		widths[223] = 666; // germandbls
		widths[224] = 666; // agrave
		widths[225] = 666; // aacute
		widths[226] = 666; // acircumflex
		widths[227] = 666; // atilde
		widths[228] = 666; // adieresis
		widths[229] = 666; // aring
		widths[230] = 1000; // ae
		widths[231] = 666; // ccedilla
		widths[232] = 666; // egrave
		widths[233] = 666; // eacute
		widths[234] = 666; // ecircumflex
		widths[235] = 666; // edieresis
		widths[236] = 333; // igrave
		widths[237] = 333; // iacute
		widths[238] = 333; // icircumflex
		widths[239] = 333; // idieresis
		widths[240] = 666; // eth
		widths[241] = 666; // ntilde
		widths[242] = 666; // ograve
		widths[243] = 666; // oacute
		widths[244] = 666; // ocircumflex
		widths[245] = 666; // otilde
		widths[246] = 666; // odieresis
		widths[247] = 660; // divide
		widths[248] = 666; // oslash
		widths[249] = 666; // ugrave
		widths[250] = 666; // uacute
		widths[251] = 666; // ucircumflex
		widths[252] = 666; // udieresis
		widths[253] = 610; // yacute
		widths[254] = 666; // thorn
		widths[255] = 610; // ydieresis
    }
}